/* sf17d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__17 = 17;

/* Subroutine */ int sf17d_c(doublereal *x, doublereal *berd, doublereal *beid,
         doublereal *akerd, doublereal *akeid, integer *ierr)
{
    /* Initialized data */

    static doublereal finity = 1.7e308;
    static doublereal e3[9] = { -5.63e-8,-1.671e-7,-1.47e-8,1.978e-6,
            1.44255e-5,7.25024e-5,-8e-10,-.026516504,1. };
    static doublereal e4[9] = { -2.69e-8,-8.83e-8,-6.992e-7,-2.0042e-6,7.9e-9,
            7.25179e-5,.001171874,.0265165034,0. };
    static doublereal sys005 = 1.5707963267948966;
    static doublereal sys011 = .39269908169872415;
    static doublereal sys003 = 6.2831853071795865;
    static doublereal sys001 = 3.1415926535897932;
    static doublereal sys039 = .57721566490153286;
    static doublereal sys029 = .70710678118654752;
    static doublereal sys059 = 1.7e308;
    static doublereal zmax = 119.;
    static doublereal ten = 10.;
    static doublereal zero = 0.;
    static doublereal half = .5;
    static doublereal d1[9] = { -1.2506046e-6,1.701453451e-4,-.013724603619,
            .6234726348243,-14.4845169498403,150.1754718432278,
            -565.1403356479486,542.5347222222147,-62.4999999999999 };
    static doublereal d2[9] = { 1.52269884e-5,-.0016331100837,.0999147064932,
            -3.2919352108579,52.1442608975905,-336.3930569023651,
            678.1684027747539,-260.4166666665533,4.9999999999993 };
    static doublereal d3[9] = { 5.23294314e-5,-.0054188558408,.3177418434686,
            -9.9412403209725,147.5144585913337,-872.2191403672455,
            1548.4845196652035,-477.4305555551536,4.9999999999975 };
    static doublereal d4[9] = { 4.3682053e-6,-5.752042283e-4,.0446263862145,
            -1.9347669229237,42.4246903131088,-408.1554788292578,
            1384.5938223372452,-1130.2806712962694,93.7499999999998 };

    /* Builtin functions */
    double log(doublereal), sin(doublereal), cos(doublereal), exp(doublereal),
             sqrt(doublereal);

    /* Local variables */
    static doublereal akei, aker;
    extern /* Subroutine */ int sf16d_c(doublereal *, doublereal *,
            doublereal *, doublereal *, doublereal *, integer *);
    static integer i__;
    static doublereal u, v, z__;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal b1, b2, b3, b4, z3, z4, dc, de, ds, um, vm, zi, r1p, 
            r2p, bei, dcm, ber, arg, con, dsm, dsq, zim, zsq;

    *ierr = 0;
    sf16d_c(x, &ber, &bei, &aker, &akei, ierr);
    z__ = abs(*x);
    if (z__ > ten) {
        goto L30;
    }
    if (z__ == zero) {
        goto L20;
    }
    z__ /= ten;
    zsq = z__ * z__;
    z3 = zsq * z__;
    z4 = zsq * zsq;
    b1 = d1[0];
    b2 = d2[0];
    b3 = d3[0];
    b4 = d4[0];
    for (i__ = 2; i__ <= 9; ++i__) {
        b1 = b1 * z4 + d1[i__ - 1];
        b2 = b2 * z4 + d2[i__ - 1];
        b3 = b3 * z4 + d3[i__ - 1];
        b4 = b4 * z4 + d4[i__ - 1];
/* L10: */
    }
    *berd = b1 * z3;
    *beid = z__ * b2;
    if (*x < zero) {
        goto L60;
    }
    r1p = z__ * b3;
    r2p = z3 * b4;
    con = log(*x * half) + sys039;
    v = abs(*x);
    *akeid = -sys005 * half * *berd + (r1p - *beid * con - bei / v);
    *akerd = sys005 * half * *beid - (r2p + *berd * con + ber / v);
    goto L90;
L20:
    *berd = zero;
    *beid = zero;
    *akeid = zero;
    *akerd = -sys059;
    goto L90;
L30:
    if (z__ > zmax) {
        goto L50;
    }
    zi = ten / z__;
    zim = -zi;
    u = e3[0];
    um = u;
    v = e4[0];
    vm = v;
    for (i__ = 2; i__ <= 9; ++i__) {
        u = u * zi + e3[i__ - 1];
        v = v * zi + e4[i__ - 1];
        um = um * zim + e3[i__ - 1];
        vm = vm * zim + e4[i__ - 1];
/* L40: */
    }
    arg = z__ * sys029;
    ds = sin(arg - sys011);
    dc = cos(arg - sys011);
    dsm = sin(arg + sys011);
    dcm = cos(arg + sys011);
    de = exp(arg);
    dsq = sqrt(sys003 * z__);
    *berd = de * (u * dcm - v * dsm) / dsq;
    *beid = de * (v * dcm + u * dsm) / dsq;
    if (*x < zero) {
        goto L60;
    }
    *akeid = -sys001 * (vm * dc - um * ds) / (de * dsq);
    *akerd = -sys001 * (um * dc + vm * ds) / (de * dsq);
    goto L90;
L50:
    *berd = zero;
    *beid = zero;
    *ierr = 66;
    if (*x < zero) {
        goto L70;
    }
    *akeid = zero;
    *akerd = zero;
    goto L80;
L60:
    *ierr = 1;
    *berd = -(*berd);
    *beid = -(*beid);
L70:
    *akerd = finity;
    *akeid = finity;
    if (*ierr == 0) {
        goto L90;
    }
L80:
    utsf11_c(ierr, &c__17);
L90:
    return 0;
} /* sf17d_c */
